/* MS3DMODEL.H - Programmed by Jonathan Hobson */
/* 120404: Added has_name() */
/* 060305: Added a style parameter */
/* 090305: Saved the style parameter */

#ifndef __MS3DMODEL_H__
#define __MS3DMODEL_H__

#include <stdio.h>
#include "ps2matrix4x4.h"
#include "ps2vector3.h"

struct MSVertex
{
	// flags, x, y, z, u, v, bone index
	int flags;
	float x, y, z, u, v;
	int bone;
	int _pad; // 16 byte align
};

struct MSTriangle
{
	// triangle: flags, vertex index1, vertex index2, vertex index3, 
	// normal index1, normal index 2, normal index 3, smoothing group
	int flags, vert1, vert2, vert3,
			   norm1, norm2, norm3, smoothinggroup;
};

struct MSMesh
{
	// mesh: name, flags, material index
	char strName[256];
	int flags, matindex;

	int nTriangles,
		nNormals,
		nVerts;

	MSVertex * pVertices;
	KazMaths::Vector3 * pNormals;
	MSTriangle * pTriangles;
};

class CMs3dModel
{
public:
	CMs3dModel(void);
	~CMs3dModel(void);

	bool Load(const char * strFilename, int style=0);
	void Render(const KazMaths::Matrix4x4 & matTrans, const KazMaths::Matrix4x4 & matWorld);
        int has_name(char *how);

protected:
	void GetNextLOC(char *pStr1024);
	void InitialiseDMA(int style);

	MSMesh * m_pMeshes;

	int m_dmaInit, m_dmaModel;
	int m_nFrames, m_nCurrentFrame, m_nMeshes;
        int ourstyle;
        float rr;
	FILE * m_fp;
        char name[32];
};

#endif
