/* TWOD.CPP - Programmed by Maarten Hofman */
/* 010504: Started programming */
/* 030804: Split rendering into two parts */
/* 011104: Added spellpoint bar */
/* 081104: Removed the spell point bar icon */

#include "twod.h"

twod::twod() {
  wm=0;
  beat=0;
  hurt=0;
}

twod::~twod() {
}

void twod::hitpoint_bar(int x,int y,int current,int max) {
int length,shade;

  length=(250*current)/max;
  shade=(128*current)/max;
  VIFDynamicDMA.StartDirect();
  VIFDynamicDMA.StartAD();
  VIFDynamicDMA.AddAD(GS_PRIM(GS_TRISTRIP,1,0,0,0,0,0,0,0), PRIM);
  VIFDynamicDMA.EndAD();
  VIFDynamicDMA.Add128(GS_GIFTAG_BATCH(4,1,0,0,GIF_FLG_REGLIST,
                       GS_BATCH_2(GIF_REG_RGBAQ,GIF_REG_XYZ2)));
  VIFDynamicDMA.Add64(RGBAQ_SET(0x80,0,0,0x80,0));
  VIFDynamicDMA.Add64(XYZ2_SET(((x+2048)<<4)-8,((y+2048)<<4)-8,0xFFFFFF));
  VIFDynamicDMA.Add64(RGBAQ_SET(0x80,0,0,0x80,0));
  VIFDynamicDMA.Add64(XYZ2_SET(((x+2048)<<4)-8,((y+2053)<<4)-8,0xFFFFFF));
  VIFDynamicDMA.Add64(RGBAQ_SET(128-shade,shade,0,0x80,0));
  VIFDynamicDMA.Add64(XYZ2_SET(((x+2048+length)<<4)-8,((y+2048)<<4)-8,
                                0xFFFFFF));
  VIFDynamicDMA.Add64(RGBAQ_SET(128-shade,shade,0,0x80,0));
  VIFDynamicDMA.Add64(XYZ2_SET(((x+2048+length)<<4)-8,((y+2053)<<4)-8,
                                0xFFFFFF));
  VIFDynamicDMA.EndDirect();
  if(current<max/2) hurt=1;
  if(current<max/4) hurt=2;
  if(!current) hurt=-1;
}

void twod::spellpoint_bar(int x,int y,int current,int max) {
int length,shade;

  length=(250*current)/max;
  shade=(128*current)/max;
  VIFDynamicDMA.StartDirect();
  VIFDynamicDMA.StartAD();
  VIFDynamicDMA.AddAD(GS_PRIM(GS_TRISTRIP,1,0,0,0,0,0,0,0), PRIM);
  VIFDynamicDMA.EndAD();
  VIFDynamicDMA.Add128(GS_GIFTAG_BATCH(4,1,0,0,GIF_FLG_REGLIST,
                       GS_BATCH_2(GIF_REG_RGBAQ,GIF_REG_XYZ2)));
  VIFDynamicDMA.Add64(RGBAQ_SET(0x80,0,0,0x80,0));
  VIFDynamicDMA.Add64(XYZ2_SET(((x+2048)<<4)-8,((y+2048)<<4)-8,0xFFFFFF));
  VIFDynamicDMA.Add64(RGBAQ_SET(0x80,0,0,0x80,0));
  VIFDynamicDMA.Add64(XYZ2_SET(((x+2048)<<4)-8,((y+2053)<<4)-8,0xFFFFFF));
  VIFDynamicDMA.Add64(RGBAQ_SET(128-shade,shade,0,0x80,0));
  VIFDynamicDMA.Add64(XYZ2_SET(((x+2048+length)<<4)-8,((y+2048)<<4)-8,
                                0xFFFFFF));
  VIFDynamicDMA.Add64(RGBAQ_SET(128-shade,shade,0,0x80,0));
  VIFDynamicDMA.Add64(XYZ2_SET(((x+2048+length)<<4)-8,((y+2053)<<4)-8,
                                0xFFFFFF));
  VIFDynamicDMA.EndDirect();
}

window *twod::open_window(int x1,int y1,int x2,int y2) {
  assert(wm<MAX_WINDOW);
  wins[wm]=new window();
  wins[wm]->set_size(x1,y1,x2,y2);
  wm++;
  return wins[wm-1];
}

void twod::render(CFont *font,int cycle) {
int i;
char heart[2];

  if((cycle==1)&&(hurt!=-1)) {
    heart[1]=0;
    if(beat<50) beat+=hurt;
    switch(beat++) {
      case 60:
      case 61:
      case 62:
      case 63:
      case 68:
      case 69:
      case 70:
      case 71:
        heart[0]=255;
        break;
      case 72:
        beat=0;
        /* Fall through expected */
      default:
        heart[0]=254;
    }
    /* Display the heart shape next to the HP bar */
    font->Render(-317,-215,heart,0x40,0x0,0x0,0x80);
  }
  for(i=0;i<wm;i++) wins[i]->render(font,cycle);
}

