Scales		.assign 0
LightDirs	.assign 1
LightCols	.assign 4
Transform	.assign 8 
LightTrans	.assign 12
LightCol	.assign 16
LightPos	.assign 17

NumVerts	.assign 0 
GifPacket  	.assign	1 
UVStart		.assign 2
NormStart	.assign 3
VertStart	.assign 4

GifPacketOut	.assign 253
UVStartOut	.assign 254
NormStartOut	.assign 255
VertStartOut	.assign 256

.include "vcl_sml.i"

.init_vf_all
.init_vi_all
.syntax new

.vu

--enter
--endenter

START:
	fcset		0x000000
	xtop		iDBOffset
	ilw.x		iNumVerts, NumVerts(iDBOffset)
	iadd		iNumVerts, iNumVerts, iDBOffset
	iadd		Counter, vi00, iDBOffset
	lq		fTransform[0], Transform+0(vi00)
	lq		fTransform[1], Transform+1(vi00)
	lq		fTransform[2], Transform+2(vi00)
	lq		fTransform[3], Transform+3(vi00)
	lq		fLightTrans[0], LightTrans+0(vi00)
	lq		fLightTrans[1], LightTrans+1(vi00)
	lq		fLightTrans[2], LightTrans+2(vi00)
	lq		fLightTrans[3], LightTrans+3(vi00)
	lq		LightCol,LightCol(vi00)
	lq		LightPos,LightPos(vi00)
	lq		fScales, Scales(vi00)
	rinit		r,LightPos[w]

loop:
; Calculate Erleng first because it takes many cycles
	lq		Vert,VertStart(Counter)
	add.xyz		Vert,fLightTrans[3],Vert
	sub.xyz		ToLight,LightPos,Vert
	erleng		p,ToLight

; Do the regular vertex stuff first
	lq		Vert, VertStart(Counter)
	mul		acc,  fTransform[0],  Vert[x]
	madd		acc,  fTransform[1],  Vert[y]
	madd		acc,  fTransform[2],  Vert[z]
	madd		Vert, fTransform[3],  Vert[w]
	clipw.xyz	Vert, Vert
	fcand		vi01, 0x3FFFF
	iaddiu		iADC, vi01, 0x7FFF
	isw.w		iADC, VertStartOut(Counter)
	div		q, vf00[w], Vert[w]
	lq		UV,   UVStart(Counter)

; Special case for fires and such
	rnext		fRandom,r
	mul.w		fResult,UV,fRandom
	add.x		UV,UV,fResult[w]

; Special case for rivers and such
        add.y		UV,UV,LightCol[w]

	mul			UV,   UV, q
	sq			UV,   UVStartOut(Counter)
	mul.xyz     Vert, Vert, q
	mula.xyz	acc, fScales, vf00[w]
	madd.xyz	Vert, Vert, fScales
	ftoi4.xyz	Vert, Vert
	sq.xyz		Vert, VertStartOut(Counter)

; Then calculate the vector lights
    lq.xyz		Norm, NormStart(Counter)
    mul.xyz     acc,  fLightTrans[0],  Norm[x]
    madd.xyz    acc,  fLightTrans[1],  Norm[y]
    madd.xyz    Norm, fLightTrans[2],  Norm[z]
    lq.xyz		fLightDirs[0], LightDirs+0(vi00)
    lq.xyz		fLightDirs[1], LightDirs+1(vi00)
    lq.xyz		fLightDirs[2], LightDirs+2(vi00)
    mula.xyz	acc, fLightDirs[0], Norm[x]
    madda.xyz	acc, fLightDirs[1], Norm[y]
    madd.xyz	fIntensities, fLightDirs[2], Norm[z]

; The point light
    mfp				fIntensity,p
    loi				6
    mul.x			fIntensity,fIntensity,i
    max.x			fIntensity,fIntensity,vf00
    mini.x              	fIntensity,fIntensity,vf00[w]
    lq				fLightCol,LightCol(vi00)
    mul				fLightCol,fLightCol,fIntensity[x]

; Calculate the vertex light colour
    mini.xyz	fIntensities, fIntensities, vf00[w]
    max.xyz		fIntensities, fIntensities, vf00[x]
    lq.xyz		fLightCols[0], LightCols+0(vi00)
    lq.xyz		fLightCols[1], LightCols+1(vi00)
    lq.xyz		fLightCols[2], LightCols+2(vi00)
    lq.xyz		fLightCols[3], LightCols+3(vi00)
    mula.xyz	acc, fLightCols[0], fIntensities[x]
    madda.xyz	acc, fLightCols[1], fIntensities[y]
    madda.xyz	acc, fLightCols[2], fIntensities[z]
    madd.xyz	fIntensities, fLightCols[3], vf00[w]

; Handle the alpha value of 70
 
    add.x		fRI,vf00,vf00[w]
    sub.x		fRI,fRI,fIntensity
    loi			70.0
    addi.x		VFRes,vf00,i
    mul.x		VFRes,VFRes,fRI
    add.w		fIntensities,vf00,VFRes[x]

; Combine point light and vertex light
    max.xyz		fIntensities,fIntensities,fLightCol
    ftoi0		fIntensities, fIntensities

; And store
	sq		fIntensities, NormStartOut(Counter) 

; Go to next item in loop
	iaddiu		Counter, Counter, 3
	ibne		Counter, iNumVerts, loop
	iaddiu		iKick, iDBOffset, GifPacketOut
	lq			GP, GifPacket(iDBOffset)
	sq			GP, GifPacketOut(iDBOffset)
	xgkick		iKick

--exit
--endexit
